import { BaseController } from '@/api/BaseController';
import { RequestOption } from '@/common/http/types';
import { ANY_OBJECT } from '@/types/generic';
import { TableData } from '@/common/types/table';
import { useUrlBuilder } from '@/common/hooks/useUrl';
import TourTravelNotesProjectRelation from '@/types/table/tourTravelNotesProjectRelation';
import { TourTourismProjectTravelNotesData } from '@/api/generated/tourTourismProjectTravelNotesController';
import { TourismProjectData } from '@/api/generated/tourismProjectController';
import { API_CONTEXT } from '../config';

const { buildGetUrl } = useUrlBuilder();

export interface TourTravelNotesProjectRelationData extends TourTravelNotesProjectRelation {
  tourTourismProjectTravelNotes?: TourTourismProjectTravelNotesData;
  tourismProject?: TourismProjectData;
  __cascade_add_temp_id__?: string | number | undefined;
}

export default class TourTravelNotesProjectRelationController extends BaseController {
  static list(params: ANY_OBJECT, httpOptions?: RequestOption) {
    return super.post<TableData<TourTravelNotesProjectRelationData>>(API_CONTEXT + '/app/tourTravelNotesProjectRelation/list', params, httpOptions);
  }
  static view(params: ANY_OBJECT, httpOptions?: RequestOption) {
    return super.get<TourTravelNotesProjectRelationData>(API_CONTEXT + '/app/tourTravelNotesProjectRelation/view', params, httpOptions);
  }
  static export(params: ANY_OBJECT, fileName: string) {
    return super.download(API_CONTEXT + '/app/tourTravelNotesProjectRelation/export', params, fileName);
  }
  static import(params: ANY_OBJECT) {
    return super.upload(API_CONTEXT + '/app/tourTravelNotesProjectRelation/import', params);
  }
  static printUrl(params: ANY_OBJECT) {
    return buildGetUrl(API_CONTEXT + '/app/tourTravelNotesProjectRelation/print', params);
  }
  static add(params: ANY_OBJECT, httpOptions?: RequestOption) {
    return super.post(API_CONTEXT + '/app/tourTravelNotesProjectRelation/add', params, httpOptions);
  }
  static update(params: ANY_OBJECT, httpOptions?: RequestOption) {
    return super.post(API_CONTEXT + '/app/tourTravelNotesProjectRelation/update', params, httpOptions);
  }
  static delete(params: ANY_OBJECT, httpOptions?: RequestOption) {
    return super.post(API_CONTEXT + '/app/tourTravelNotesProjectRelation/delete', params, httpOptions);
  }
  static deleteBatch(params: ANY_OBJECT, httpOptions?: RequestOption) {
    return super.post(API_CONTEXT + '/app/tourTravelNotesProjectRelation/deleteBatch', params, httpOptions);
  }
}
